package ca.sanae.golemcomputers.blocks

import ca.sanae.golemcomputers.GolemComputers
import ca.sanae.golemcomputers.computer.Computer
import net.fabricmc.api.EnvType
import net.fabricmc.api.Environment
import net.minecraft.block.BlockState
import net.minecraft.block.entity.BlockEntity
import net.minecraft.nbt.NbtCompound
import net.minecraft.registry.RegistryWrapper
import net.minecraft.util.math.BlockPos
import net.minecraft.world.World

class GolemBlockEntity(pos: BlockPos?, state: BlockState?) :
  BlockEntity(GolemComputers.GOLEM_BLOCK_ENTITY, pos, state) {
  private var computer: Computer? = null

  fun getClicks(): Int {
    return 0
  }

  fun incrementClicks() {
    markDirty()
  }

  override fun writeNbt(nbt: NbtCompound, registries: RegistryWrapper.WrapperLookup?) {
    nbt.putInt("clicks", 0)
    super.writeNbt(nbt, registries)
  }

  override fun readNbt(nbt: NbtCompound, registries: RegistryWrapper.WrapperLookup?) {
    nbt.getInt("clicks")
    super.readNbt(nbt, registries)
  }

  override fun setWorld(world: World?) {
    computer = if (!world!!.isClient) Computer(world) else null
    super.setWorld(world)
  }

  fun tick() {
    computer?.tick()
  }
}